// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: BinaryStateDefinition.proto

package ru.omnicomm.pegasus.messaging.settings.binarySensor;

public final class BinaryStateDefinitionSettingsParser {
  private BinaryStateDefinitionSettingsParser() {}
  public static void registerAllExtensions(
      com.google.protobuf.ExtensionRegistry registry) {
  }
  public interface BinaryStateDefinitionSettingsOrBuilder
      extends com.google.protobuf.MessageOrBuilder {
    
    // required int32 sourceId = 1;
    boolean hasSourceId();
    int getSourceId();
    
    // optional int32 messageType = 2 [default = 532];
    boolean hasMessageType();
    int getMessageType();
    
    // required int32 messageTime = 3;
    boolean hasMessageTime();
    int getMessageTime();
    
    // optional int32 idleMAX = 103 [default = 480];
    boolean hasIdleMAX();
    int getIdleMAX();
  }
  public static final class BinaryStateDefinitionSettings extends
      com.google.protobuf.GeneratedMessage
      implements BinaryStateDefinitionSettingsOrBuilder {
    // Use BinaryStateDefinitionSettings.newBuilder() to construct.
    private BinaryStateDefinitionSettings(Builder builder) {
      super(builder);
    }
    private BinaryStateDefinitionSettings(boolean noInit) {}
    
    private static final BinaryStateDefinitionSettings defaultInstance;
    public static BinaryStateDefinitionSettings getDefaultInstance() {
      return defaultInstance;
    }
    
    public BinaryStateDefinitionSettings getDefaultInstanceForType() {
      return defaultInstance;
    }
    
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_binarySensor_BinaryStateDefinitionSettings_descriptor;
    }
    
    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_binarySensor_BinaryStateDefinitionSettings_fieldAccessorTable;
    }
    
    private int bitField0_;
    // required int32 sourceId = 1;
    public static final int SOURCEID_FIELD_NUMBER = 1;
    private int sourceId_;
    public boolean hasSourceId() {
      return ((bitField0_ & 0x00000001) == 0x00000001);
    }
    public int getSourceId() {
      return sourceId_;
    }
    
    // optional int32 messageType = 2 [default = 532];
    public static final int MESSAGETYPE_FIELD_NUMBER = 2;
    private int messageType_;
    public boolean hasMessageType() {
      return ((bitField0_ & 0x00000002) == 0x00000002);
    }
    public int getMessageType() {
      return messageType_;
    }
    
    // required int32 messageTime = 3;
    public static final int MESSAGETIME_FIELD_NUMBER = 3;
    private int messageTime_;
    public boolean hasMessageTime() {
      return ((bitField0_ & 0x00000004) == 0x00000004);
    }
    public int getMessageTime() {
      return messageTime_;
    }
    
    // optional int32 idleMAX = 103 [default = 480];
    public static final int IDLEMAX_FIELD_NUMBER = 103;
    private int idleMAX_;
    public boolean hasIdleMAX() {
      return ((bitField0_ & 0x00000008) == 0x00000008);
    }
    public int getIdleMAX() {
      return idleMAX_;
    }
    
    private void initFields() {
      sourceId_ = 0;
      messageType_ = 532;
      messageTime_ = 0;
      idleMAX_ = 480;
    }
    private byte memoizedIsInitialized = -1;
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized != -1) return isInitialized == 1;
      
      if (!hasSourceId()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!hasMessageTime()) {
        memoizedIsInitialized = 0;
        return false;
      }
      memoizedIsInitialized = 1;
      return true;
    }
    
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        output.writeInt32(1, sourceId_);
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        output.writeInt32(2, messageType_);
      }
      if (((bitField0_ & 0x00000004) == 0x00000004)) {
        output.writeInt32(3, messageTime_);
      }
      if (((bitField0_ & 0x00000008) == 0x00000008)) {
        output.writeInt32(103, idleMAX_);
      }
      getUnknownFields().writeTo(output);
    }
    
    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;
    
      size = 0;
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(1, sourceId_);
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(2, messageType_);
      }
      if (((bitField0_ & 0x00000004) == 0x00000004)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(3, messageTime_);
      }
      if (((bitField0_ & 0x00000008) == 0x00000008)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(103, idleMAX_);
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }
    
    private static final long serialVersionUID = 0L;
    @java.lang.Override
    protected java.lang.Object writeReplace()
        throws java.io.ObjectStreamException {
      return super.writeReplace();
    }
    
    public static ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionSettings parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionSettings parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionSettings parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionSettings parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionSettings parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionSettings parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionSettings parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionSettings parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input, extensionRegistry)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionSettings parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionSettings parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    
    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionSettings prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }
    
    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessage.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder>
       implements ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionSettingsOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_binarySensor_BinaryStateDefinitionSettings_descriptor;
      }
      
      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_binarySensor_BinaryStateDefinitionSettings_fieldAccessorTable;
      }
      
      // Construct using ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionSettings.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }
      
      private Builder(BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
        }
      }
      private static Builder create() {
        return new Builder();
      }
      
      public Builder clear() {
        super.clear();
        sourceId_ = 0;
        bitField0_ = (bitField0_ & ~0x00000001);
        messageType_ = 532;
        bitField0_ = (bitField0_ & ~0x00000002);
        messageTime_ = 0;
        bitField0_ = (bitField0_ & ~0x00000004);
        idleMAX_ = 480;
        bitField0_ = (bitField0_ & ~0x00000008);
        return this;
      }
      
      public Builder clone() {
        return create().mergeFrom(buildPartial());
      }
      
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionSettings.getDescriptor();
      }
      
      public ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionSettings getDefaultInstanceForType() {
        return ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionSettings.getDefaultInstance();
      }
      
      public ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionSettings build() {
        ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionSettings result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }
      
      private ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionSettings buildParsed()
          throws com.google.protobuf.InvalidProtocolBufferException {
        ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionSettings result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(
            result).asInvalidProtocolBufferException();
        }
        return result;
      }
      
      public ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionSettings buildPartial() {
        ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionSettings result = new ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionSettings(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) == 0x00000001)) {
          to_bitField0_ |= 0x00000001;
        }
        result.sourceId_ = sourceId_;
        if (((from_bitField0_ & 0x00000002) == 0x00000002)) {
          to_bitField0_ |= 0x00000002;
        }
        result.messageType_ = messageType_;
        if (((from_bitField0_ & 0x00000004) == 0x00000004)) {
          to_bitField0_ |= 0x00000004;
        }
        result.messageTime_ = messageTime_;
        if (((from_bitField0_ & 0x00000008) == 0x00000008)) {
          to_bitField0_ |= 0x00000008;
        }
        result.idleMAX_ = idleMAX_;
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }
      
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionSettings) {
          return mergeFrom((ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionSettings)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }
      
      public Builder mergeFrom(ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionSettings other) {
        if (other == ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionSettings.getDefaultInstance()) return this;
        if (other.hasSourceId()) {
          setSourceId(other.getSourceId());
        }
        if (other.hasMessageType()) {
          setMessageType(other.getMessageType());
        }
        if (other.hasMessageTime()) {
          setMessageTime(other.getMessageTime());
        }
        if (other.hasIdleMAX()) {
          setIdleMAX(other.getIdleMAX());
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }
      
      public final boolean isInitialized() {
        if (!hasSourceId()) {
          
          return false;
        }
        if (!hasMessageTime()) {
          
          return false;
        }
        return true;
      }
      
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder(
            this.getUnknownFields());
        while (true) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              this.setUnknownFields(unknownFields.build());
              onChanged();
              return this;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                this.setUnknownFields(unknownFields.build());
                onChanged();
                return this;
              }
              break;
            }
            case 8: {
              bitField0_ |= 0x00000001;
              sourceId_ = input.readInt32();
              break;
            }
            case 16: {
              bitField0_ |= 0x00000002;
              messageType_ = input.readInt32();
              break;
            }
            case 24: {
              bitField0_ |= 0x00000004;
              messageTime_ = input.readInt32();
              break;
            }
            case 824: {
              bitField0_ |= 0x00000008;
              idleMAX_ = input.readInt32();
              break;
            }
          }
        }
      }
      
      private int bitField0_;
      
      // required int32 sourceId = 1;
      private int sourceId_ ;
      public boolean hasSourceId() {
        return ((bitField0_ & 0x00000001) == 0x00000001);
      }
      public int getSourceId() {
        return sourceId_;
      }
      public Builder setSourceId(int value) {
        bitField0_ |= 0x00000001;
        sourceId_ = value;
        onChanged();
        return this;
      }
      public Builder clearSourceId() {
        bitField0_ = (bitField0_ & ~0x00000001);
        sourceId_ = 0;
        onChanged();
        return this;
      }
      
      // optional int32 messageType = 2 [default = 532];
      private int messageType_ = 532;
      public boolean hasMessageType() {
        return ((bitField0_ & 0x00000002) == 0x00000002);
      }
      public int getMessageType() {
        return messageType_;
      }
      public Builder setMessageType(int value) {
        bitField0_ |= 0x00000002;
        messageType_ = value;
        onChanged();
        return this;
      }
      public Builder clearMessageType() {
        bitField0_ = (bitField0_ & ~0x00000002);
        messageType_ = 532;
        onChanged();
        return this;
      }
      
      // required int32 messageTime = 3;
      private int messageTime_ ;
      public boolean hasMessageTime() {
        return ((bitField0_ & 0x00000004) == 0x00000004);
      }
      public int getMessageTime() {
        return messageTime_;
      }
      public Builder setMessageTime(int value) {
        bitField0_ |= 0x00000004;
        messageTime_ = value;
        onChanged();
        return this;
      }
      public Builder clearMessageTime() {
        bitField0_ = (bitField0_ & ~0x00000004);
        messageTime_ = 0;
        onChanged();
        return this;
      }
      
      // optional int32 idleMAX = 103 [default = 480];
      private int idleMAX_ = 480;
      public boolean hasIdleMAX() {
        return ((bitField0_ & 0x00000008) == 0x00000008);
      }
      public int getIdleMAX() {
        return idleMAX_;
      }
      public Builder setIdleMAX(int value) {
        bitField0_ |= 0x00000008;
        idleMAX_ = value;
        onChanged();
        return this;
      }
      public Builder clearIdleMAX() {
        bitField0_ = (bitField0_ & ~0x00000008);
        idleMAX_ = 480;
        onChanged();
        return this;
      }
      
      // @@protoc_insertion_point(builder_scope:ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettings)
    }
    
    static {
      defaultInstance = new BinaryStateDefinitionSettings(true);
      defaultInstance.initFields();
    }
    
    // @@protoc_insertion_point(class_scope:ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettings)
  }
  
  public interface BinaryStateDefinitionBufferOrBuilder
      extends com.google.protobuf.MessageOrBuilder {
    
    // required int32 sourceId = 1;
    boolean hasSourceId();
    int getSourceId();
    
    // optional int32 messageType = 2 [default = 533];
    boolean hasMessageType();
    int getMessageType();
    
    // required int32 messageTime = 3;
    boolean hasMessageTime();
    int getMessageTime();
    
    // optional int32 idleMAX = 103;
    boolean hasIdleMAX();
    int getIdleMAX();
    
    // repeated .ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionBuffer.Data buffer = 105;
    java.util.List<ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data> 
        getBufferList();
    ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data getBuffer(int index);
    int getBufferCount();
    java.util.List<? extends ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.DataOrBuilder> 
        getBufferOrBuilderList();
    ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.DataOrBuilder getBufferOrBuilder(
        int index);
  }
  public static final class BinaryStateDefinitionBuffer extends
      com.google.protobuf.GeneratedMessage
      implements BinaryStateDefinitionBufferOrBuilder {
    // Use BinaryStateDefinitionBuffer.newBuilder() to construct.
    private BinaryStateDefinitionBuffer(Builder builder) {
      super(builder);
    }
    private BinaryStateDefinitionBuffer(boolean noInit) {}
    
    private static final BinaryStateDefinitionBuffer defaultInstance;
    public static BinaryStateDefinitionBuffer getDefaultInstance() {
      return defaultInstance;
    }
    
    public BinaryStateDefinitionBuffer getDefaultInstanceForType() {
      return defaultInstance;
    }
    
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_binarySensor_BinaryStateDefinitionBuffer_descriptor;
    }
    
    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_binarySensor_BinaryStateDefinitionBuffer_fieldAccessorTable;
    }
    
    public interface DataOrBuilder
        extends com.google.protobuf.MessageOrBuilder {
      
      // optional int32 dataId = 1;
      boolean hasDataId();
      int getDataId();
      
      // optional bool value = 2;
      boolean hasValue();
      boolean getValue();
    }
    public static final class Data extends
        com.google.protobuf.GeneratedMessage
        implements DataOrBuilder {
      // Use Data.newBuilder() to construct.
      private Data(Builder builder) {
        super(builder);
      }
      private Data(boolean noInit) {}
      
      private static final Data defaultInstance;
      public static Data getDefaultInstance() {
        return defaultInstance;
      }
      
      public Data getDefaultInstanceForType() {
        return defaultInstance;
      }
      
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_binarySensor_BinaryStateDefinitionBuffer_Data_descriptor;
      }
      
      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_binarySensor_BinaryStateDefinitionBuffer_Data_fieldAccessorTable;
      }
      
      private int bitField0_;
      // optional int32 dataId = 1;
      public static final int DATAID_FIELD_NUMBER = 1;
      private int dataId_;
      public boolean hasDataId() {
        return ((bitField0_ & 0x00000001) == 0x00000001);
      }
      public int getDataId() {
        return dataId_;
      }
      
      // optional bool value = 2;
      public static final int VALUE_FIELD_NUMBER = 2;
      private boolean value_;
      public boolean hasValue() {
        return ((bitField0_ & 0x00000002) == 0x00000002);
      }
      public boolean getValue() {
        return value_;
      }
      
      private void initFields() {
        dataId_ = 0;
        value_ = false;
      }
      private byte memoizedIsInitialized = -1;
      public final boolean isInitialized() {
        byte isInitialized = memoizedIsInitialized;
        if (isInitialized != -1) return isInitialized == 1;
        
        memoizedIsInitialized = 1;
        return true;
      }
      
      public void writeTo(com.google.protobuf.CodedOutputStream output)
                          throws java.io.IOException {
        getSerializedSize();
        if (((bitField0_ & 0x00000001) == 0x00000001)) {
          output.writeInt32(1, dataId_);
        }
        if (((bitField0_ & 0x00000002) == 0x00000002)) {
          output.writeBool(2, value_);
        }
        getUnknownFields().writeTo(output);
      }
      
      private int memoizedSerializedSize = -1;
      public int getSerializedSize() {
        int size = memoizedSerializedSize;
        if (size != -1) return size;
      
        size = 0;
        if (((bitField0_ & 0x00000001) == 0x00000001)) {
          size += com.google.protobuf.CodedOutputStream
            .computeInt32Size(1, dataId_);
        }
        if (((bitField0_ & 0x00000002) == 0x00000002)) {
          size += com.google.protobuf.CodedOutputStream
            .computeBoolSize(2, value_);
        }
        size += getUnknownFields().getSerializedSize();
        memoizedSerializedSize = size;
        return size;
      }
      
      private static final long serialVersionUID = 0L;
      @java.lang.Override
      protected java.lang.Object writeReplace()
          throws java.io.ObjectStreamException {
        return super.writeReplace();
      }
      
      public static ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data parseFrom(
          com.google.protobuf.ByteString data)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data parseFrom(
          com.google.protobuf.ByteString data,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data, extensionRegistry)
                 .buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data parseFrom(byte[] data)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data parseFrom(
          byte[] data,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data, extensionRegistry)
                 .buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data parseFrom(java.io.InputStream input)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data parseFrom(
          java.io.InputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input, extensionRegistry)
                 .buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data parseDelimitedFrom(java.io.InputStream input)
          throws java.io.IOException {
        Builder builder = newBuilder();
        if (builder.mergeDelimitedFrom(input)) {
          return builder.buildParsed();
        } else {
          return null;
        }
      }
      public static ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data parseDelimitedFrom(
          java.io.InputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        Builder builder = newBuilder();
        if (builder.mergeDelimitedFrom(input, extensionRegistry)) {
          return builder.buildParsed();
        } else {
          return null;
        }
      }
      public static ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data parseFrom(
          com.google.protobuf.CodedInputStream input)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data parseFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input, extensionRegistry)
                 .buildParsed();
      }
      
      public static Builder newBuilder() { return Builder.create(); }
      public Builder newBuilderForType() { return newBuilder(); }
      public static Builder newBuilder(ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data prototype) {
        return newBuilder().mergeFrom(prototype);
      }
      public Builder toBuilder() { return newBuilder(this); }
      
      @java.lang.Override
      protected Builder newBuilderForType(
          com.google.protobuf.GeneratedMessage.BuilderParent parent) {
        Builder builder = new Builder(parent);
        return builder;
      }
      public static final class Builder extends
          com.google.protobuf.GeneratedMessage.Builder<Builder>
         implements ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.DataOrBuilder {
        public static final com.google.protobuf.Descriptors.Descriptor
            getDescriptor() {
          return ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_binarySensor_BinaryStateDefinitionBuffer_Data_descriptor;
        }
        
        protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
            internalGetFieldAccessorTable() {
          return ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_binarySensor_BinaryStateDefinitionBuffer_Data_fieldAccessorTable;
        }
        
        // Construct using ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data.newBuilder()
        private Builder() {
          maybeForceBuilderInitialization();
        }
        
        private Builder(BuilderParent parent) {
          super(parent);
          maybeForceBuilderInitialization();
        }
        private void maybeForceBuilderInitialization() {
          if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
          }
        }
        private static Builder create() {
          return new Builder();
        }
        
        public Builder clear() {
          super.clear();
          dataId_ = 0;
          bitField0_ = (bitField0_ & ~0x00000001);
          value_ = false;
          bitField0_ = (bitField0_ & ~0x00000002);
          return this;
        }
        
        public Builder clone() {
          return create().mergeFrom(buildPartial());
        }
        
        public com.google.protobuf.Descriptors.Descriptor
            getDescriptorForType() {
          return ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data.getDescriptor();
        }
        
        public ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data getDefaultInstanceForType() {
          return ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data.getDefaultInstance();
        }
        
        public ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data build() {
          ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data result = buildPartial();
          if (!result.isInitialized()) {
            throw newUninitializedMessageException(result);
          }
          return result;
        }
        
        private ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data buildParsed()
            throws com.google.protobuf.InvalidProtocolBufferException {
          ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data result = buildPartial();
          if (!result.isInitialized()) {
            throw newUninitializedMessageException(
              result).asInvalidProtocolBufferException();
          }
          return result;
        }
        
        public ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data buildPartial() {
          ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data result = new ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data(this);
          int from_bitField0_ = bitField0_;
          int to_bitField0_ = 0;
          if (((from_bitField0_ & 0x00000001) == 0x00000001)) {
            to_bitField0_ |= 0x00000001;
          }
          result.dataId_ = dataId_;
          if (((from_bitField0_ & 0x00000002) == 0x00000002)) {
            to_bitField0_ |= 0x00000002;
          }
          result.value_ = value_;
          result.bitField0_ = to_bitField0_;
          onBuilt();
          return result;
        }
        
        public Builder mergeFrom(com.google.protobuf.Message other) {
          if (other instanceof ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data) {
            return mergeFrom((ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data)other);
          } else {
            super.mergeFrom(other);
            return this;
          }
        }
        
        public Builder mergeFrom(ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data other) {
          if (other == ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data.getDefaultInstance()) return this;
          if (other.hasDataId()) {
            setDataId(other.getDataId());
          }
          if (other.hasValue()) {
            setValue(other.getValue());
          }
          this.mergeUnknownFields(other.getUnknownFields());
          return this;
        }
        
        public final boolean isInitialized() {
          return true;
        }
        
        public Builder mergeFrom(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
          com.google.protobuf.UnknownFieldSet.Builder unknownFields =
            com.google.protobuf.UnknownFieldSet.newBuilder(
              this.getUnknownFields());
          while (true) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                this.setUnknownFields(unknownFields.build());
                onChanged();
                return this;
              default: {
                if (!parseUnknownField(input, unknownFields,
                                       extensionRegistry, tag)) {
                  this.setUnknownFields(unknownFields.build());
                  onChanged();
                  return this;
                }
                break;
              }
              case 8: {
                bitField0_ |= 0x00000001;
                dataId_ = input.readInt32();
                break;
              }
              case 16: {
                bitField0_ |= 0x00000002;
                value_ = input.readBool();
                break;
              }
            }
          }
        }
        
        private int bitField0_;
        
        // optional int32 dataId = 1;
        private int dataId_ ;
        public boolean hasDataId() {
          return ((bitField0_ & 0x00000001) == 0x00000001);
        }
        public int getDataId() {
          return dataId_;
        }
        public Builder setDataId(int value) {
          bitField0_ |= 0x00000001;
          dataId_ = value;
          onChanged();
          return this;
        }
        public Builder clearDataId() {
          bitField0_ = (bitField0_ & ~0x00000001);
          dataId_ = 0;
          onChanged();
          return this;
        }
        
        // optional bool value = 2;
        private boolean value_ ;
        public boolean hasValue() {
          return ((bitField0_ & 0x00000002) == 0x00000002);
        }
        public boolean getValue() {
          return value_;
        }
        public Builder setValue(boolean value) {
          bitField0_ |= 0x00000002;
          value_ = value;
          onChanged();
          return this;
        }
        public Builder clearValue() {
          bitField0_ = (bitField0_ & ~0x00000002);
          value_ = false;
          onChanged();
          return this;
        }
        
        // @@protoc_insertion_point(builder_scope:ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionBuffer.Data)
      }
      
      static {
        defaultInstance = new Data(true);
        defaultInstance.initFields();
      }
      
      // @@protoc_insertion_point(class_scope:ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionBuffer.Data)
    }
    
    private int bitField0_;
    // required int32 sourceId = 1;
    public static final int SOURCEID_FIELD_NUMBER = 1;
    private int sourceId_;
    public boolean hasSourceId() {
      return ((bitField0_ & 0x00000001) == 0x00000001);
    }
    public int getSourceId() {
      return sourceId_;
    }
    
    // optional int32 messageType = 2 [default = 533];
    public static final int MESSAGETYPE_FIELD_NUMBER = 2;
    private int messageType_;
    public boolean hasMessageType() {
      return ((bitField0_ & 0x00000002) == 0x00000002);
    }
    public int getMessageType() {
      return messageType_;
    }
    
    // required int32 messageTime = 3;
    public static final int MESSAGETIME_FIELD_NUMBER = 3;
    private int messageTime_;
    public boolean hasMessageTime() {
      return ((bitField0_ & 0x00000004) == 0x00000004);
    }
    public int getMessageTime() {
      return messageTime_;
    }
    
    // optional int32 idleMAX = 103;
    public static final int IDLEMAX_FIELD_NUMBER = 103;
    private int idleMAX_;
    public boolean hasIdleMAX() {
      return ((bitField0_ & 0x00000008) == 0x00000008);
    }
    public int getIdleMAX() {
      return idleMAX_;
    }
    
    // repeated .ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionBuffer.Data buffer = 105;
    public static final int BUFFER_FIELD_NUMBER = 105;
    private java.util.List<ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data> buffer_;
    public java.util.List<ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data> getBufferList() {
      return buffer_;
    }
    public java.util.List<? extends ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.DataOrBuilder> 
        getBufferOrBuilderList() {
      return buffer_;
    }
    public int getBufferCount() {
      return buffer_.size();
    }
    public ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data getBuffer(int index) {
      return buffer_.get(index);
    }
    public ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.DataOrBuilder getBufferOrBuilder(
        int index) {
      return buffer_.get(index);
    }
    
    private void initFields() {
      sourceId_ = 0;
      messageType_ = 533;
      messageTime_ = 0;
      idleMAX_ = 0;
      buffer_ = java.util.Collections.emptyList();
    }
    private byte memoizedIsInitialized = -1;
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized != -1) return isInitialized == 1;
      
      if (!hasSourceId()) {
        memoizedIsInitialized = 0;
        return false;
      }
      if (!hasMessageTime()) {
        memoizedIsInitialized = 0;
        return false;
      }
      memoizedIsInitialized = 1;
      return true;
    }
    
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        output.writeInt32(1, sourceId_);
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        output.writeInt32(2, messageType_);
      }
      if (((bitField0_ & 0x00000004) == 0x00000004)) {
        output.writeInt32(3, messageTime_);
      }
      if (((bitField0_ & 0x00000008) == 0x00000008)) {
        output.writeInt32(103, idleMAX_);
      }
      for (int i = 0; i < buffer_.size(); i++) {
        output.writeMessage(105, buffer_.get(i));
      }
      getUnknownFields().writeTo(output);
    }
    
    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;
    
      size = 0;
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(1, sourceId_);
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(2, messageType_);
      }
      if (((bitField0_ & 0x00000004) == 0x00000004)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(3, messageTime_);
      }
      if (((bitField0_ & 0x00000008) == 0x00000008)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt32Size(103, idleMAX_);
      }
      for (int i = 0; i < buffer_.size(); i++) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(105, buffer_.get(i));
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }
    
    private static final long serialVersionUID = 0L;
    @java.lang.Override
    protected java.lang.Object writeReplace()
        throws java.io.ObjectStreamException {
      return super.writeReplace();
    }
    
    public static ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input, extensionRegistry)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    
    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }
    
    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessage.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder>
       implements ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBufferOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_binarySensor_BinaryStateDefinitionBuffer_descriptor;
      }
      
      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_binarySensor_BinaryStateDefinitionBuffer_fieldAccessorTable;
      }
      
      // Construct using ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }
      
      private Builder(BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
          getBufferFieldBuilder();
        }
      }
      private static Builder create() {
        return new Builder();
      }
      
      public Builder clear() {
        super.clear();
        sourceId_ = 0;
        bitField0_ = (bitField0_ & ~0x00000001);
        messageType_ = 533;
        bitField0_ = (bitField0_ & ~0x00000002);
        messageTime_ = 0;
        bitField0_ = (bitField0_ & ~0x00000004);
        idleMAX_ = 0;
        bitField0_ = (bitField0_ & ~0x00000008);
        if (bufferBuilder_ == null) {
          buffer_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000010);
        } else {
          bufferBuilder_.clear();
        }
        return this;
      }
      
      public Builder clone() {
        return create().mergeFrom(buildPartial());
      }
      
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.getDescriptor();
      }
      
      public ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer getDefaultInstanceForType() {
        return ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.getDefaultInstance();
      }
      
      public ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer build() {
        ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }
      
      private ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer buildParsed()
          throws com.google.protobuf.InvalidProtocolBufferException {
        ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(
            result).asInvalidProtocolBufferException();
        }
        return result;
      }
      
      public ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer buildPartial() {
        ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer result = new ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) == 0x00000001)) {
          to_bitField0_ |= 0x00000001;
        }
        result.sourceId_ = sourceId_;
        if (((from_bitField0_ & 0x00000002) == 0x00000002)) {
          to_bitField0_ |= 0x00000002;
        }
        result.messageType_ = messageType_;
        if (((from_bitField0_ & 0x00000004) == 0x00000004)) {
          to_bitField0_ |= 0x00000004;
        }
        result.messageTime_ = messageTime_;
        if (((from_bitField0_ & 0x00000008) == 0x00000008)) {
          to_bitField0_ |= 0x00000008;
        }
        result.idleMAX_ = idleMAX_;
        if (bufferBuilder_ == null) {
          if (((bitField0_ & 0x00000010) == 0x00000010)) {
            buffer_ = java.util.Collections.unmodifiableList(buffer_);
            bitField0_ = (bitField0_ & ~0x00000010);
          }
          result.buffer_ = buffer_;
        } else {
          result.buffer_ = bufferBuilder_.build();
        }
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }
      
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer) {
          return mergeFrom((ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }
      
      public Builder mergeFrom(ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer other) {
        if (other == ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.getDefaultInstance()) return this;
        if (other.hasSourceId()) {
          setSourceId(other.getSourceId());
        }
        if (other.hasMessageType()) {
          setMessageType(other.getMessageType());
        }
        if (other.hasMessageTime()) {
          setMessageTime(other.getMessageTime());
        }
        if (other.hasIdleMAX()) {
          setIdleMAX(other.getIdleMAX());
        }
        if (bufferBuilder_ == null) {
          if (!other.buffer_.isEmpty()) {
            if (buffer_.isEmpty()) {
              buffer_ = other.buffer_;
              bitField0_ = (bitField0_ & ~0x00000010);
            } else {
              ensureBufferIsMutable();
              buffer_.addAll(other.buffer_);
            }
            onChanged();
          }
        } else {
          if (!other.buffer_.isEmpty()) {
            if (bufferBuilder_.isEmpty()) {
              bufferBuilder_.dispose();
              bufferBuilder_ = null;
              buffer_ = other.buffer_;
              bitField0_ = (bitField0_ & ~0x00000010);
              bufferBuilder_ = 
                com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders ?
                   getBufferFieldBuilder() : null;
            } else {
              bufferBuilder_.addAllMessages(other.buffer_);
            }
          }
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }
      
      public final boolean isInitialized() {
        if (!hasSourceId()) {
          
          return false;
        }
        if (!hasMessageTime()) {
          
          return false;
        }
        return true;
      }
      
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder(
            this.getUnknownFields());
        while (true) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              this.setUnknownFields(unknownFields.build());
              onChanged();
              return this;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                this.setUnknownFields(unknownFields.build());
                onChanged();
                return this;
              }
              break;
            }
            case 8: {
              bitField0_ |= 0x00000001;
              sourceId_ = input.readInt32();
              break;
            }
            case 16: {
              bitField0_ |= 0x00000002;
              messageType_ = input.readInt32();
              break;
            }
            case 24: {
              bitField0_ |= 0x00000004;
              messageTime_ = input.readInt32();
              break;
            }
            case 824: {
              bitField0_ |= 0x00000008;
              idleMAX_ = input.readInt32();
              break;
            }
            case 842: {
              ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data.Builder subBuilder = ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data.newBuilder();
              input.readMessage(subBuilder, extensionRegistry);
              addBuffer(subBuilder.buildPartial());
              break;
            }
          }
        }
      }
      
      private int bitField0_;
      
      // required int32 sourceId = 1;
      private int sourceId_ ;
      public boolean hasSourceId() {
        return ((bitField0_ & 0x00000001) == 0x00000001);
      }
      public int getSourceId() {
        return sourceId_;
      }
      public Builder setSourceId(int value) {
        bitField0_ |= 0x00000001;
        sourceId_ = value;
        onChanged();
        return this;
      }
      public Builder clearSourceId() {
        bitField0_ = (bitField0_ & ~0x00000001);
        sourceId_ = 0;
        onChanged();
        return this;
      }
      
      // optional int32 messageType = 2 [default = 533];
      private int messageType_ = 533;
      public boolean hasMessageType() {
        return ((bitField0_ & 0x00000002) == 0x00000002);
      }
      public int getMessageType() {
        return messageType_;
      }
      public Builder setMessageType(int value) {
        bitField0_ |= 0x00000002;
        messageType_ = value;
        onChanged();
        return this;
      }
      public Builder clearMessageType() {
        bitField0_ = (bitField0_ & ~0x00000002);
        messageType_ = 533;
        onChanged();
        return this;
      }
      
      // required int32 messageTime = 3;
      private int messageTime_ ;
      public boolean hasMessageTime() {
        return ((bitField0_ & 0x00000004) == 0x00000004);
      }
      public int getMessageTime() {
        return messageTime_;
      }
      public Builder setMessageTime(int value) {
        bitField0_ |= 0x00000004;
        messageTime_ = value;
        onChanged();
        return this;
      }
      public Builder clearMessageTime() {
        bitField0_ = (bitField0_ & ~0x00000004);
        messageTime_ = 0;
        onChanged();
        return this;
      }
      
      // optional int32 idleMAX = 103;
      private int idleMAX_ ;
      public boolean hasIdleMAX() {
        return ((bitField0_ & 0x00000008) == 0x00000008);
      }
      public int getIdleMAX() {
        return idleMAX_;
      }
      public Builder setIdleMAX(int value) {
        bitField0_ |= 0x00000008;
        idleMAX_ = value;
        onChanged();
        return this;
      }
      public Builder clearIdleMAX() {
        bitField0_ = (bitField0_ & ~0x00000008);
        idleMAX_ = 0;
        onChanged();
        return this;
      }
      
      // repeated .ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionBuffer.Data buffer = 105;
      private java.util.List<ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data> buffer_ =
        java.util.Collections.emptyList();
      private void ensureBufferIsMutable() {
        if (!((bitField0_ & 0x00000010) == 0x00000010)) {
          buffer_ = new java.util.ArrayList<ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data>(buffer_);
          bitField0_ |= 0x00000010;
         }
      }
      
      private com.google.protobuf.RepeatedFieldBuilder<
          ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data, ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data.Builder, ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.DataOrBuilder> bufferBuilder_;
      
      public java.util.List<ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data> getBufferList() {
        if (bufferBuilder_ == null) {
          return java.util.Collections.unmodifiableList(buffer_);
        } else {
          return bufferBuilder_.getMessageList();
        }
      }
      public int getBufferCount() {
        if (bufferBuilder_ == null) {
          return buffer_.size();
        } else {
          return bufferBuilder_.getCount();
        }
      }
      public ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data getBuffer(int index) {
        if (bufferBuilder_ == null) {
          return buffer_.get(index);
        } else {
          return bufferBuilder_.getMessage(index);
        }
      }
      public Builder setBuffer(
          int index, ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data value) {
        if (bufferBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureBufferIsMutable();
          buffer_.set(index, value);
          onChanged();
        } else {
          bufferBuilder_.setMessage(index, value);
        }
        return this;
      }
      public Builder setBuffer(
          int index, ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data.Builder builderForValue) {
        if (bufferBuilder_ == null) {
          ensureBufferIsMutable();
          buffer_.set(index, builderForValue.build());
          onChanged();
        } else {
          bufferBuilder_.setMessage(index, builderForValue.build());
        }
        return this;
      }
      public Builder addBuffer(ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data value) {
        if (bufferBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureBufferIsMutable();
          buffer_.add(value);
          onChanged();
        } else {
          bufferBuilder_.addMessage(value);
        }
        return this;
      }
      public Builder addBuffer(
          int index, ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data value) {
        if (bufferBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureBufferIsMutable();
          buffer_.add(index, value);
          onChanged();
        } else {
          bufferBuilder_.addMessage(index, value);
        }
        return this;
      }
      public Builder addBuffer(
          ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data.Builder builderForValue) {
        if (bufferBuilder_ == null) {
          ensureBufferIsMutable();
          buffer_.add(builderForValue.build());
          onChanged();
        } else {
          bufferBuilder_.addMessage(builderForValue.build());
        }
        return this;
      }
      public Builder addBuffer(
          int index, ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data.Builder builderForValue) {
        if (bufferBuilder_ == null) {
          ensureBufferIsMutable();
          buffer_.add(index, builderForValue.build());
          onChanged();
        } else {
          bufferBuilder_.addMessage(index, builderForValue.build());
        }
        return this;
      }
      public Builder addAllBuffer(
          java.lang.Iterable<? extends ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data> values) {
        if (bufferBuilder_ == null) {
          ensureBufferIsMutable();
          super.addAll(values, buffer_);
          onChanged();
        } else {
          bufferBuilder_.addAllMessages(values);
        }
        return this;
      }
      public Builder clearBuffer() {
        if (bufferBuilder_ == null) {
          buffer_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000010);
          onChanged();
        } else {
          bufferBuilder_.clear();
        }
        return this;
      }
      public Builder removeBuffer(int index) {
        if (bufferBuilder_ == null) {
          ensureBufferIsMutable();
          buffer_.remove(index);
          onChanged();
        } else {
          bufferBuilder_.remove(index);
        }
        return this;
      }
      public ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data.Builder getBufferBuilder(
          int index) {
        return getBufferFieldBuilder().getBuilder(index);
      }
      public ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.DataOrBuilder getBufferOrBuilder(
          int index) {
        if (bufferBuilder_ == null) {
          return buffer_.get(index);  } else {
          return bufferBuilder_.getMessageOrBuilder(index);
        }
      }
      public java.util.List<? extends ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.DataOrBuilder> 
           getBufferOrBuilderList() {
        if (bufferBuilder_ != null) {
          return bufferBuilder_.getMessageOrBuilderList();
        } else {
          return java.util.Collections.unmodifiableList(buffer_);
        }
      }
      public ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data.Builder addBufferBuilder() {
        return getBufferFieldBuilder().addBuilder(
            ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data.getDefaultInstance());
      }
      public ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data.Builder addBufferBuilder(
          int index) {
        return getBufferFieldBuilder().addBuilder(
            index, ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data.getDefaultInstance());
      }
      public java.util.List<ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data.Builder> 
           getBufferBuilderList() {
        return getBufferFieldBuilder().getBuilderList();
      }
      private com.google.protobuf.RepeatedFieldBuilder<
          ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data, ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data.Builder, ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.DataOrBuilder> 
          getBufferFieldBuilder() {
        if (bufferBuilder_ == null) {
          bufferBuilder_ = new com.google.protobuf.RepeatedFieldBuilder<
              ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data, ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data.Builder, ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.DataOrBuilder>(
                  buffer_,
                  ((bitField0_ & 0x00000010) == 0x00000010),
                  getParentForChildren(),
                  isClean());
          buffer_ = null;
        }
        return bufferBuilder_;
      }
      
      // @@protoc_insertion_point(builder_scope:ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionBuffer)
    }
    
    static {
      defaultInstance = new BinaryStateDefinitionBuffer(true);
      defaultInstance.initFields();
    }
    
    // @@protoc_insertion_point(class_scope:ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionBuffer)
  }
  
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_ru_omnicomm_pegasus_messaging_settings_binarySensor_BinaryStateDefinitionSettings_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_ru_omnicomm_pegasus_messaging_settings_binarySensor_BinaryStateDefinitionSettings_fieldAccessorTable;
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_ru_omnicomm_pegasus_messaging_settings_binarySensor_BinaryStateDefinitionBuffer_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_ru_omnicomm_pegasus_messaging_settings_binarySensor_BinaryStateDefinitionBuffer_fieldAccessorTable;
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_ru_omnicomm_pegasus_messaging_settings_binarySensor_BinaryStateDefinitionBuffer_Data_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_ru_omnicomm_pegasus_messaging_settings_binarySensor_BinaryStateDefinitionBuffer_Data_fieldAccessorTable;
  
  public static com.google.protobuf.Descriptors.FileDescriptor
      getDescriptor() {
    return descriptor;
  }
  private static com.google.protobuf.Descriptors.FileDescriptor
      descriptor;
  static {
    java.lang.String[] descriptorData = {
      "\n\033BinaryStateDefinition.proto\0223ru.omnico" +
      "mm.pegasus.messaging.settings.binarySens" +
      "or\"v\n\035BinaryStateDefinitionSettings\022\020\n\010s" +
      "ourceId\030\001 \002(\005\022\030\n\013messageType\030\002 \001(\005:\003532\022" +
      "\023\n\013messageTime\030\003 \002(\005\022\024\n\007idleMAX\030g \001(\005:\0034" +
      "80\"\375\001\n\033BinaryStateDefinitionBuffer\022\020\n\010so" +
      "urceId\030\001 \002(\005\022\030\n\013messageType\030\002 \001(\005:\003533\022\023" +
      "\n\013messageTime\030\003 \002(\005\022\017\n\007idleMAX\030g \001(\005\022e\n\006" +
      "buffer\030i \003(\0132U.ru.omnicomm.pegasus.messa" +
      "ging.settings.binarySensor.BinaryStateDe",
      "finitionBuffer.Data\032%\n\004Data\022\016\n\006dataId\030\001 " +
      "\001(\005\022\r\n\005value\030\002 \001(\010BZ\n3ru.omnicomm.pegasu" +
      "s.messaging.settings.binarySensorB#Binar" +
      "yStateDefinitionSettingsParser"
    };
    com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner assigner =
      new com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner() {
        public com.google.protobuf.ExtensionRegistry assignDescriptors(
            com.google.protobuf.Descriptors.FileDescriptor root) {
          descriptor = root;
          internal_static_ru_omnicomm_pegasus_messaging_settings_binarySensor_BinaryStateDefinitionSettings_descriptor =
            getDescriptor().getMessageTypes().get(0);
          internal_static_ru_omnicomm_pegasus_messaging_settings_binarySensor_BinaryStateDefinitionSettings_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_ru_omnicomm_pegasus_messaging_settings_binarySensor_BinaryStateDefinitionSettings_descriptor,
              new java.lang.String[] { "SourceId", "MessageType", "MessageTime", "IdleMAX", },
              ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionSettings.class,
              ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionSettings.Builder.class);
          internal_static_ru_omnicomm_pegasus_messaging_settings_binarySensor_BinaryStateDefinitionBuffer_descriptor =
            getDescriptor().getMessageTypes().get(1);
          internal_static_ru_omnicomm_pegasus_messaging_settings_binarySensor_BinaryStateDefinitionBuffer_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_ru_omnicomm_pegasus_messaging_settings_binarySensor_BinaryStateDefinitionBuffer_descriptor,
              new java.lang.String[] { "SourceId", "MessageType", "MessageTime", "IdleMAX", "Buffer", },
              ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.class,
              ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Builder.class);
          internal_static_ru_omnicomm_pegasus_messaging_settings_binarySensor_BinaryStateDefinitionBuffer_Data_descriptor =
            internal_static_ru_omnicomm_pegasus_messaging_settings_binarySensor_BinaryStateDefinitionBuffer_descriptor.getNestedTypes().get(0);
          internal_static_ru_omnicomm_pegasus_messaging_settings_binarySensor_BinaryStateDefinitionBuffer_Data_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_ru_omnicomm_pegasus_messaging_settings_binarySensor_BinaryStateDefinitionBuffer_Data_descriptor,
              new java.lang.String[] { "DataId", "Value", },
              ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data.class,
              ru.omnicomm.pegasus.messaging.settings.binarySensor.BinaryStateDefinitionSettingsParser.BinaryStateDefinitionBuffer.Data.Builder.class);
          return null;
        }
      };
    com.google.protobuf.Descriptors.FileDescriptor
      .internalBuildGeneratedFileFrom(descriptorData,
        new com.google.protobuf.Descriptors.FileDescriptor[] {
        }, assigner);
  }
  
  // @@protoc_insertion_point(outer_class_scope)
}
